package b4a.spyspider;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.spyspider", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "b4a.spyspider", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper _server = null;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _astream = null;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.objects.streams.File.TextWriterWrapper _textwriter1 = null;
public static boolean _connected = false;
public static anywheresoftware.b4a.objects.Timer _moveforward = null;
public static anywheresoftware.b4a.objects.Timer _moverevers = null;
public static anywheresoftware.b4a.objects.Timer _turnleft = null;
public static anywheresoftware.b4a.objects.Timer _turnright = null;
public static byte _j = 0;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblip = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfw = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnl = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnr = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnrv = null;
public static boolean _move_forward_flag = false;
public static boolean _move_revers_flag = false;
public static boolean _turn_left_flag = false;
public static boolean _turn_right_flag = false;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 35;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 36;BA.debugLine="Serial1.Initialize(\"Serial1\")";
_serial1.Initialize("Serial1");
 };
 //BA.debugLineNum = 38;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 39;BA.debugLine="Activity.AddMenuItem(\"Connect\", \"mnuConnect\")";
mostCurrent._activity.AddMenuItem("Connect","mnuConnect");
 //BA.debugLineNum = 40;BA.debugLine="Activity.AddMenuItem(\"Disconnect\", \"mnuDisconnect\")";
mostCurrent._activity.AddMenuItem("Disconnect","mnuDisconnect");
 //BA.debugLineNum = 41;BA.debugLine="server.Initialize(17178, \"server\")";
_server.Initialize(processBA,(int)(17178),"server");
 //BA.debugLineNum = 42;BA.debugLine="moveforward.Initialize(\"moveforward\",100)";
_moveforward.Initialize(processBA,"moveforward",(long)(100));
 //BA.debugLineNum = 43;BA.debugLine="moverevers.Initialize(\"moverevers\",100)";
_moverevers.Initialize(processBA,"moverevers",(long)(100));
 //BA.debugLineNum = 44;BA.debugLine="turnleft.Initialize(\"turnleft\",100)";
_turnleft.Initialize(processBA,"turnleft",(long)(100));
 //BA.debugLineNum = 45;BA.debugLine="turnright.Initialize(\"turnright\",100)";
_turnright.Initialize(processBA,"turnright",(long)(100));
 //BA.debugLineNum = 46;BA.debugLine="server.Listen";
_server.Listen();
 //BA.debugLineNum = 47;BA.debugLine="lblip.Text = \"My IP: \" & server.GetMyIP";
mostCurrent._lblip.setText((Object)("My IP: "+_server.GetMyIP()));
 //BA.debugLineNum = 48;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 128;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 130;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 83;BA.debugLine="If Serial1.IsEnabled = False Then";
if (_serial1.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 84;BA.debugLine="Msgbox(\"Please enable Bluetooth.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Please enable Bluetooth.","",mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 86;BA.debugLine="Serial1.Listen 'listen for incoming connections";
_serial1.Listen(processBA);
 };
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static String  _astream_error() throws Exception{
 //BA.debugLineNum = 72;BA.debugLine="Sub astream_Error";
 //BA.debugLineNum = 73;BA.debugLine="Log(\"Error: \" & LastException)";
anywheresoftware.b4a.keywords.Common.Log("Error: "+String.valueOf(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)));
 //BA.debugLineNum = 74;BA.debugLine="astream.Close";
_astream.Close();
 //BA.debugLineNum = 75;BA.debugLine="astream_Terminated";
_astream_terminated();
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static String  _astream_newdata(byte[] _buffer) throws Exception{
anywheresoftware.b4a.objects.streams.File.InputStreamWrapper _in = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _img = null;
 //BA.debugLineNum = 62;BA.debugLine="Sub astream_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 63;BA.debugLine="Log(\"received: \" & DateTime.GetSecond(DateTime.Now))";
anywheresoftware.b4a.keywords.Common.Log("received: "+BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetSecond(anywheresoftware.b4a.keywords.Common.DateTime.getNow())));
 //BA.debugLineNum = 64;BA.debugLine="Dim In As InputStream";
_in = new anywheresoftware.b4a.objects.streams.File.InputStreamWrapper();
 //BA.debugLineNum = 65;BA.debugLine="Log(Buffer.Length)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_buffer.length));
 //BA.debugLineNum = 66;BA.debugLine="In.InitializeFromBytesArray(Buffer, 0, Buffer.Length)";
_in.InitializeFromBytesArray(_buffer,(int)(0),_buffer.length);
 //BA.debugLineNum = 67;BA.debugLine="Dim img As Bitmap";
_img = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 68;BA.debugLine="img.Initialize2(In)";
_img.Initialize2((java.io.InputStream)(_in.getObject()));
 //BA.debugLineNum = 69;BA.debugLine="ImageView1.SetBackgroundImage(img)";
mostCurrent._imageview1.SetBackgroundImage((android.graphics.Bitmap)(_img.getObject()));
 //BA.debugLineNum = 70;BA.debugLine="End Sub";
return "";
}
public static String  _astream_terminated() throws Exception{
 //BA.debugLineNum = 78;BA.debugLine="Sub astream_Terminated";
 //BA.debugLineNum = 79;BA.debugLine="ToastMessageShow(\"Disconnect\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Disconnect",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _btnfw_down() throws Exception{
 //BA.debugLineNum = 169;BA.debugLine="Sub btnfw_Down";
 //BA.debugLineNum = 170;BA.debugLine="move_forward_flag = True";
_move_forward_flag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 171;BA.debugLine="End Sub";
return "";
}
public static String  _btnfw_up() throws Exception{
 //BA.debugLineNum = 172;BA.debugLine="Sub btnfw_Up";
 //BA.debugLineNum = 173;BA.debugLine="move_forward_flag = False";
_move_forward_flag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 174;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 175;BA.debugLine="For j = 0 To 10";
{
final double step154 = 1;
final double limit154 = (byte)(10);
for (_j = (byte)(0); (step154 > 0 && _j <= limit154) || (step154 < 0 && _j >= limit154); _j += step154) {
 //BA.debugLineNum = 176;BA.debugLine="TextWriter1.Write(\"s\")";
_textwriter1.Write("s");
 //BA.debugLineNum = 177;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 }
};
 };
 //BA.debugLineNum = 180;BA.debugLine="End Sub";
return "";
}
public static String  _btnl_down() throws Exception{
 //BA.debugLineNum = 157;BA.debugLine="Sub btnl_Down";
 //BA.debugLineNum = 158;BA.debugLine="turn_left_flag = True";
_turn_left_flag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 159;BA.debugLine="End Sub";
return "";
}
public static String  _btnl_up() throws Exception{
 //BA.debugLineNum = 160;BA.debugLine="Sub btnl_Up";
 //BA.debugLineNum = 161;BA.debugLine="turn_left_flag = False";
_turn_left_flag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 162;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 163;BA.debugLine="For j = 0 To 10";
{
final double step142 = 1;
final double limit142 = (byte)(10);
for (_j = (byte)(0); (step142 > 0 && _j <= limit142) || (step142 < 0 && _j >= limit142); _j += step142) {
 //BA.debugLineNum = 164;BA.debugLine="TextWriter1.Write(\"s\")";
_textwriter1.Write("s");
 //BA.debugLineNum = 165;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 }
};
 };
 //BA.debugLineNum = 168;BA.debugLine="End Sub";
return "";
}
public static String  _btnr_down() throws Exception{
 //BA.debugLineNum = 145;BA.debugLine="Sub btnr_Down";
 //BA.debugLineNum = 146;BA.debugLine="turn_right_flag = True";
_turn_right_flag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 147;BA.debugLine="End Sub";
return "";
}
public static String  _btnr_up() throws Exception{
 //BA.debugLineNum = 148;BA.debugLine="Sub btnr_Up";
 //BA.debugLineNum = 149;BA.debugLine="turn_right_flag = False";
_turn_right_flag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 150;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 151;BA.debugLine="For j = 0 To 10";
{
final double step130 = 1;
final double limit130 = (byte)(10);
for (_j = (byte)(0); (step130 > 0 && _j <= limit130) || (step130 < 0 && _j >= limit130); _j += step130) {
 //BA.debugLineNum = 152;BA.debugLine="TextWriter1.Write(\"s\")";
_textwriter1.Write("s");
 //BA.debugLineNum = 153;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 }
};
 };
 //BA.debugLineNum = 156;BA.debugLine="End Sub";
return "";
}
public static String  _btnrv_down() throws Exception{
 //BA.debugLineNum = 132;BA.debugLine="Sub btnrv_Down";
 //BA.debugLineNum = 133;BA.debugLine="move_revers_flag = True";
_move_revers_flag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 134;BA.debugLine="End Sub";
return "";
}
public static String  _btnrv_up() throws Exception{
 //BA.debugLineNum = 135;BA.debugLine="Sub btnrv_Up";
 //BA.debugLineNum = 136;BA.debugLine="move_revers_flag = False";
_move_revers_flag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 137;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 138;BA.debugLine="For j = 0 To 10";
{
final double step118 = 1;
final double limit118 = (byte)(10);
for (_j = (byte)(0); (step118 > 0 && _j <= limit118) || (step118 < 0 && _j >= limit118); _j += step118) {
 //BA.debugLineNum = 139;BA.debugLine="TextWriter1.Write(\"s\")";
_textwriter1.Write("s");
 //BA.debugLineNum = 140;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 }
};
 };
 //BA.debugLineNum = 144;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Dim lblip As Label";
mostCurrent._lblip = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim btnfw As Button";
mostCurrent._btnfw = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Dim btnl As Button";
mostCurrent._btnl = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Dim btnr As Button";
mostCurrent._btnr = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim btnrv As Button";
mostCurrent._btnrv = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim move_forward_flag As Boolean";
_move_forward_flag = false;
 //BA.debugLineNum = 28;BA.debugLine="Dim move_revers_flag As Boolean";
_move_revers_flag = false;
 //BA.debugLineNum = 29;BA.debugLine="Dim turn_left_flag As Boolean";
_turn_left_flag = false;
 //BA.debugLineNum = 30;BA.debugLine="Dim turn_right_flag As Boolean";
_turn_right_flag = false;
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static String  _mnuconnect_click() throws Exception{
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
int _res = 0;
 //BA.debugLineNum = 90;BA.debugLine="Sub mnuConnect_Click";
 //BA.debugLineNum = 91;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 92;BA.debugLine="PairedDevices = Serial1.GetPairedDevices";
_paireddevices = _serial1.GetPairedDevices();
 //BA.debugLineNum = 93;BA.debugLine="Dim l As List";
_l = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 94;BA.debugLine="l.Initialize";
_l.Initialize();
 //BA.debugLineNum = 95;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final double step79 = 1;
final double limit79 = (int)(_paireddevices.getSize()-1);
for (_i = (int)(0); (step79 > 0 && _i <= limit79) || (step79 < 0 && _i >= limit79); _i += step79) {
 //BA.debugLineNum = 96;BA.debugLine="l.Add(PairedDevices.GetKeyAt(i))";
_l.Add(_paireddevices.GetKeyAt(_i));
 }
};
 //BA.debugLineNum = 98;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 99;BA.debugLine="res = InputList(l, \"Choose device\", -1) 'show list with paired devices";
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Choose device",(int)(-1),mostCurrent.activityBA);
 //BA.debugLineNum = 100;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 101;BA.debugLine="Serial1.Connect(PairedDevices.Get(l.Get(res))) 'convert the name to mac address";
_serial1.Connect(processBA,String.valueOf(_paireddevices.Get(_l.Get(_res))));
 };
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return "";
}
public static String  _mnudisconnect_click() throws Exception{
 //BA.debugLineNum = 119;BA.debugLine="Sub mnuDisconnect_Click";
 //BA.debugLineNum = 120;BA.debugLine="Serial1.Disconnect";
_serial1.Disconnect();
 //BA.debugLineNum = 121;BA.debugLine="moveforward.Enabled = False";
_moveforward.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 122;BA.debugLine="moverevers.Enabled = False";
_moverevers.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 123;BA.debugLine="turnleft.Enabled = False";
_turnleft.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 124;BA.debugLine="turnright.Enabled = False";
_turnright.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 125;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _moveforward_tick() throws Exception{
 //BA.debugLineNum = 182;BA.debugLine="Sub moveforward_tick";
 //BA.debugLineNum = 183;BA.debugLine="If move_forward_flag = True Then";
if (_move_forward_flag==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 184;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 185;BA.debugLine="TextWriter1.Write(\"0\")";
_textwriter1.Write("0");
 //BA.debugLineNum = 186;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 };
 //BA.debugLineNum = 189;BA.debugLine="End Sub";
return "";
}
public static String  _moverevers_tick() throws Exception{
 //BA.debugLineNum = 190;BA.debugLine="Sub moverevers_tick";
 //BA.debugLineNum = 191;BA.debugLine="If move_revers_flag = True Then";
if (_move_revers_flag==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 192;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 193;BA.debugLine="TextWriter1.Write(\"1\")";
_textwriter1.Write("1");
 //BA.debugLineNum = 194;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 };
 //BA.debugLineNum = 197;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 5;BA.debugLine="Private server As ServerSocket";
_server = new anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper();
 //BA.debugLineNum = 6;BA.debugLine="Private astream As AsyncStreams";
_astream = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 7;BA.debugLine="Dim Serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 8;BA.debugLine="Dim TextWriter1 As TextWriter";
_textwriter1 = new anywheresoftware.b4a.objects.streams.File.TextWriterWrapper();
 //BA.debugLineNum = 9;BA.debugLine="Dim connected As Boolean";
_connected = false;
 //BA.debugLineNum = 10;BA.debugLine="Dim moveforward As Timer";
_moveforward = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 11;BA.debugLine="Dim moverevers As Timer";
_moverevers = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 12;BA.debugLine="Dim turnleft As Timer";
_turnleft = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 13;BA.debugLine="Dim turnright As Timer";
_turnright = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 14;BA.debugLine="Dim j As Byte";
_j = 0;
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 105;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
 //BA.debugLineNum = 106;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 107;BA.debugLine="ToastMessageShow(\"Connected successfully\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Connected successfully",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 108;BA.debugLine="TextWriter1.Initialize(Serial1.OutputStream)";
_textwriter1.Initialize(_serial1.getOutputStream());
 //BA.debugLineNum = 109;BA.debugLine="moveforward.Enabled = True";
_moveforward.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 110;BA.debugLine="moverevers.Enabled = True";
_moverevers.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 111;BA.debugLine="turnleft.Enabled = True";
_turnleft.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 112;BA.debugLine="turnright.Enabled = True";
_turnright.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 113;BA.debugLine="connected = True";
_connected = anywheresoftware.b4a.keywords.Common.True;
 }else {
 //BA.debugLineNum = 115;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 116;BA.debugLine="Msgbox(LastException.Message, \"Error connecting.\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"Error connecting.",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 118;BA.debugLine="End Sub";
return "";
}
public static String  _server_newconnection(boolean _successful,anywheresoftware.b4a.objects.SocketWrapper _newsocket) throws Exception{
 //BA.debugLineNum = 50;BA.debugLine="Sub Server_NewConnection (Successful As Boolean, NewSocket As Socket)";
 //BA.debugLineNum = 51;BA.debugLine="If Successful Then";
if (_successful) { 
 //BA.debugLineNum = 52;BA.debugLine="ToastMessageShow(\"Connected successfully\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Connected successfully",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 53;BA.debugLine="lblip.Visible = False";
mostCurrent._lblip.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 54;BA.debugLine="If astream.IsInitialized Then astream.Close";
if (_astream.IsInitialized()) { 
_astream.Close();};
 //BA.debugLineNum = 55;BA.debugLine="astream.InitializePrefix(NewSocket.InputStream, False, NewSocket.OutputStream, \"astream\")";
_astream.InitializePrefix(processBA,_newsocket.getInputStream(),anywheresoftware.b4a.keywords.Common.False,_newsocket.getOutputStream(),"astream");
 }else {
 //BA.debugLineNum = 57;BA.debugLine="Log(LastException)";
anywheresoftware.b4a.keywords.Common.Log(String.valueOf(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA)));
 };
 //BA.debugLineNum = 59;BA.debugLine="server.Listen";
_server.Listen();
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _turnleft_tick() throws Exception{
 //BA.debugLineNum = 198;BA.debugLine="Sub turnleft_tick";
 //BA.debugLineNum = 199;BA.debugLine="If turn_left_flag = True Then";
if (_turn_left_flag==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 200;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 201;BA.debugLine="TextWriter1.Write(\"2\")";
_textwriter1.Write("2");
 //BA.debugLineNum = 202;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 };
 //BA.debugLineNum = 205;BA.debugLine="End Sub";
return "";
}
public static String  _turnright_tick() throws Exception{
 //BA.debugLineNum = 206;BA.debugLine="Sub turnright_tick";
 //BA.debugLineNum = 207;BA.debugLine="If turn_right_flag = True Then";
if (_turn_right_flag==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 208;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 209;BA.debugLine="TextWriter1.Write(\"3\")";
_textwriter1.Write("3");
 //BA.debugLineNum = 210;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 };
 //BA.debugLineNum = 213;BA.debugLine="End Sub";
return "";
}
}
